#include "../../model/geometry/density_legend_geometry.h"
#include "../../view/state0.h"
#include "../actions/set_ortho.h"
#include "reshape.h"
#include <GL/glut.h>

#define S state0

void
reshape (int w, int h)
{
  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();

  /*
   * This scaling produces an odd effect when the coordinates are not
   * centered at 0,0.  When 0,0 is the lower left rather than the
   * center this reshape is a bit unnatural since the image is not
   * centered in the middle of the window.
   */

  if (w <= h)
    {
      S.ortho.min_x = S.ortho_min;
      S.ortho.max_x = S.ortho_max;
      S.ortho.min_y = S.ortho_min * (double) h / (double) w;
      S.ortho.max_y = S.ortho_max * (double) h / (double) w;
    }
  else
    {
      S.ortho.min_x = S.ortho_min * (double) w / (double) h;
      S.ortho.max_x = S.ortho_max * (double) w / (double) h;
      S.ortho.min_y = S.ortho_min;
      S.ortho.max_y = S.ortho_max;
    }

  set_ortho ();

  glMatrixMode (GL_MODELVIEW);

  // Set the viewport equal to the size of the window.
  glViewport (0, 0, (GLsizei) w, (GLsizei) h);

  S.viewport.w = w;
  S.viewport.h = h;

  density_legend_geometry ();

  return;
}
